#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define all(x) x.first(),x.second()
#define MAXN 500005
using namespace std;
int n, k,domet,poslednji;
int niz[MAXN];
set<pair<int,int> > s;
vector<int> res;
int main(){
    scanf("%d %d", &n, &k);
    for(int i=1;i<=n;i++){
        scanf("%d",niz+i);
    }
    domet=k;
    for(int i=1;i<=k;i++){
        s.insert(mp(niz[i],i));
    }
    do{
        domet++;

        s.insert(mp(niz[domet],domet));
        while(s.begin()->second<poslednji){
            s.erase(s.begin());
        }
        res.pb((s.begin()->first));
        poslednji=s.begin()->second;
        s.erase(s.begin());

    }while(domet<n);
    for(auto x:res)printf("%d ",x);

    return 0;
}